public class Crossdiagram {
  private final String caption;
  private final String minText;
  private final String middleText;
  private final String maxText;
  private float xMin;
  private float xMax;
  private float yMin;
  private float yMax;
  private float xAxis;
  private float yAxis;
  
  Crossdiagram(float xMin, float xMax, float yMin, float yMax, String caption, String minText, String middleText, String maxText) {
    this.caption = caption;
    this.minText = minText;
    this.middleText = middleText;
    this.maxText = maxText;
    this.xMin = xMin;  // kleinste x Wert | kleinste x Koordinate
    this.xMax = xMax;  // größte x Wert | größte x Koordinate
    this.yMin = yMin;  // größte y Wert | kleinste y Koordinate
    this.yMax = yMax;  // kleinste y Wert | größte y Koordinate
  }
  
  private void drawAxes() {  // Achsen und Beschriftung zeichnen
    // auf weißer Fläche zeichnen
    noStroke();
    fill(255);
    rect(xMin-15, yMin-15, xMax-xMin+30, yMax-yMin+30);
    
    textAlign(CENTER);
    fill(0);
    text(caption, xMin+(xMax-xMin)/2, yMax+10);
    
    xAxis = xMin+(xMax-xMin)/2;
    yAxis = yMin+(yMax-yMin)/2;
    
    //x-Achsen Werte:
    text(minText, xMin, yMax);
    text(middleText, xAxis, yMax);
    text(maxText, xMax, yMax);
    
    // y-Achsen Werte
    text(minText, xMin, yMax);
    text(middleText, xMin, yAxis);
    text(maxText, xMin, yMin);
    
    stroke(150);
    strokeWeight(1);
    line(xMin, yAxis, xMax, yAxis);  // x Achse
    line(xAxis, yMin, xAxis, yMax);  // y Achse
  }
  
  public void drawFinPosition(float finUpDown, float finLeftRight) {
    drawAxes();  // übermalt veraltete Linien
    strokeWeight(1);
    stroke(0, 0, 255);
    
    // 0° entspricht jeweils -45° und 180° 45° (eventuell Winkelbereich der Servos anpassen):
    float xPosTemp = map(finLeftRight, 0, 180, xMin, xMax);  
    //println("xPosTemp: " + xPosTemp);
    float yPosTemp = map(finUpDown, 0, 180, yMax, yMin);
    //println("yPosTemp: " + yPosTemp);
    
    line(xMin, yPosTemp, xMax, yPosTemp);  // horizontale Finnen Position
    line(xPosTemp, yMin, xPosTemp, yMax);  // vertikale Finnen Position
  }
};
