// Klasse zur Erstellung von Echtzeitplots mithilfe des grafica-Bibliothek
public class LivePlotDiagram {
  private GPlot plot;
  private StringList legendText = new StringList();
  private FloatList legendPosX = new FloatList();
  private FloatList legendPosY = new FloatList();
  
  LivePlotDiagram(PApplet parent, float xPos, float yPos, float plotWidth, float plotHeight, String caption, String xAxisLabel, String yAxisLabel) {
    this.plot = new GPlot(parent, xPos, yPos, plotWidth, plotHeight);
    plot.setTitleText(caption);
    plot.getXAxis().setAxisLabelText(xAxisLabel);
    plot.getYAxis().setAxisLabelText(yAxisLabel);
  }
  
  // Diagramm aktualisieren
  private void updateChart() {
    plot.beginDraw();
    plot.drawBackground();
    plot.drawBox();
    plot.drawXAxis();
    plot.drawYAxis();
    plot.drawTitle();
    plot.drawLines();
    //plot.drawLegend(legendText.array(), legendPosX.array(), legendPosY.array());
    plot.updateLimits();
    plot.endDraw();
  }
  
  // neuen Graph zum Diagramm hinzufügen
  public void addLayer(String layerName, color lineColor) {
    GPointsArray gpoints =  new GPointsArray();
    gpoints.add(new PVector(0, 0));
    plot.addLayer(layerName, gpoints);
    plot.getLayer(layerName).setLineColor(lineColor);
    //legendText.append(layerName);
    //legendPosX.append(0.4);
    //legendPosY.append(0.95 - legendPosY.size() * 0.06);
  }
  
  // Graph akzualisieren
  public void updateLayer(String layerName, ArrayList<PVector> points) {
    plot.getLayer(layerName).setPoints(new GPointsArray(points));
    //printArray(points);
    updateChart();
  }
}
