// Klasse soll aktuelle Zustände des Arduinos festhalten
public class VirtualArduino {
  private float timestamp = 0;
  private int finUpDownPosition, finLeftRightPosition, motorDrivePosition, ptLeftValue, ptRightValue, ptDownValue, batteryVoltageValue; // aktuelle Werte
  private float distanceLeftValue, distanceRightValue;                                                                             // aktuelle Werte
  
  // die letzten bis zu 100 Werte der jeweiligen Eigenschaft als Ringbuffer von Ortsvektoren bestehend aus x = Zeitstempel und y = Wert:
  private ArrayList<PVector> finUpDownPositionRingBuffer = new ArrayList<PVector>();
  private ArrayList<PVector> finLeftRightPositionRingBuffer = new ArrayList<PVector>();
  private ArrayList<PVector> motorDrivePositionRingBuffer = new ArrayList<PVector>();
  private ArrayList<PVector> distanceLeftValueRingBuffer = new ArrayList<PVector>();
  private ArrayList<PVector> distanceRightValueRingBuffer = new ArrayList<PVector>();
  private ArrayList<PVector> ptLeftValueRingBuffer = new ArrayList<PVector>();
  private ArrayList<PVector> ptRightValueRingBuffer = new ArrayList<PVector>();
  private ArrayList<PVector> ptDownValueRingBuffer = new ArrayList<PVector>();
  private ArrayList<PVector> batteryVoltageValueRingBuffer = new ArrayList<PVector>();
  private int RingBufferMaxLength = 100;
  
  VirtualArduino() {
    
  }
  
  // Getter-Funktionen für die entsprechenden Werte:
  
  public float getTimestamp() {
    return timestamp;
  }
  
  public int getFinUpDownPosition() {
    return finUpDownPosition;
  }
  
  public int getFinLeftRightPosition() {
    return finLeftRightPosition;
  }
  
  public int getMotorDrivePosition() {
    return motorDrivePosition;
  }
  
  public int getPTLeftValue() {
    return ptLeftValue;
  }
  
  public int getPTRightValue() {
    return ptRightValue;
  }
  
  public int getPTDownValue() {
    return ptDownValue;
  }
  
  public int getBatteryVoltageValue() {
    return batteryVoltageValue;
  }
  
  public float getDistanceLeftValue() {
    return distanceLeftValue;
  }
  
  public float getDistanceRightValue() {
    return distanceRightValue;
  }
  
  
  public ArrayList<PVector> getFinUpDownPositionRingBuffer() {
    return finUpDownPositionRingBuffer;
  }
  
  public ArrayList<PVector> getFinLeftRightPositionRingBuffer() {
    return finLeftRightPositionRingBuffer;
  }
  
  public ArrayList<PVector> getMotorDrivePositionRingBuffer() {
    return motorDrivePositionRingBuffer;
  }
  
  public ArrayList<PVector> getPTLeftValueRingBuffer() {
    return ptLeftValueRingBuffer;
  }
  
  public ArrayList<PVector> getPTRightValueRingBuffer() {
    return ptRightValueRingBuffer;
  }
  
  public ArrayList<PVector> getPTDownValueRingBuffer() {
    return ptDownValueRingBuffer;
  }
  
  public ArrayList<PVector> getBatteryVoltageValueRingBuffer() {
    return batteryVoltageValueRingBuffer;
  }
  
  public ArrayList<PVector> getDistanceLeftValueRingBuffer() {
    return distanceLeftValueRingBuffer;
  }
  
  public ArrayList<PVector> getDistanceRightValueRingBuffer() {
    return distanceRightValueRingBuffer;
  }
  
  // Setter-Funktionen für die ensprechenden Werte:
  
  public void updateTimestamp(float newTimestamp) {
    this.timestamp = newTimestamp;
  }
  
  public void updateFinUpDownPosition(int newFinUpDownPosition) {
    finUpDownPosition = newFinUpDownPosition;
    finUpDownPositionRingBuffer.add(new PVector(timestamp, newFinUpDownPosition));
    if (finUpDownPositionRingBuffer.size() > RingBufferMaxLength) {
      finUpDownPositionRingBuffer.remove(0);
    }
  }
  
  public void updateFinLeftRightPosition(int newFinLeftRightPosition) {
    finLeftRightPosition = newFinLeftRightPosition;
    finLeftRightPositionRingBuffer.add(new PVector(timestamp, newFinLeftRightPosition));
    if (finLeftRightPositionRingBuffer.size() > RingBufferMaxLength) {
      finLeftRightPositionRingBuffer.remove(0);
    }
  }
  
  public void updateMotorDrivePosition(int newMotorDrivePosition) {
    motorDrivePosition = newMotorDrivePosition;
    motorDrivePositionRingBuffer.add(new PVector(timestamp, newMotorDrivePosition));
    if (motorDrivePositionRingBuffer.size() > RingBufferMaxLength) {
      motorDrivePositionRingBuffer.remove(0);
    }
  }
  
  public void updateDistanceLeftValue(float newDistanceLeftValue) {
    distanceLeftValue = newDistanceLeftValue;
    distanceLeftValueRingBuffer.add(new PVector(timestamp, newDistanceLeftValue));
    if (distanceLeftValueRingBuffer.size() > RingBufferMaxLength) {
      distanceLeftValueRingBuffer.remove(0);
    }
  }
  
  public void updateDistanceRightValue(float newDistanceRightValue) {
    distanceRightValue = newDistanceRightValue;
    distanceRightValueRingBuffer.add(new PVector(timestamp, newDistanceRightValue));
    if (distanceRightValueRingBuffer.size() > RingBufferMaxLength) {
      distanceRightValueRingBuffer.remove(0);
    }
  }
  
  public void updatePTLeftValue(int newptLeftValue) {
    ptLeftValue = newptLeftValue;
    ptLeftValueRingBuffer.add(new PVector(timestamp, newptLeftValue));
    if (ptLeftValueRingBuffer.size() > RingBufferMaxLength) {
      ptLeftValueRingBuffer.remove(0);
    }
  }
  
  public void updateBatteryVoltageValue(int newBatteryVoltageValue) {
    batteryVoltageValue = newBatteryVoltageValue;
    batteryVoltageValueRingBuffer.add(new PVector(timestamp, newBatteryVoltageValue));
    if (batteryVoltageValueRingBuffer.size() > RingBufferMaxLength) {
      batteryVoltageValueRingBuffer.remove(0);
    }
  }
  
  public void updatePTRightValue(int newptRightValue) {
    ptRightValue = newptRightValue;
    ptRightValueRingBuffer.add(new PVector(timestamp, newptRightValue));
    if (ptRightValueRingBuffer.size() > RingBufferMaxLength) {
      ptRightValueRingBuffer.remove(0);
    }
  }
  
  public void updatePTDownValue(int newptDownValue) {
    ptDownValue = newptDownValue;
    ptDownValueRingBuffer.add(new PVector(timestamp, newptDownValue));
    if (ptDownValueRingBuffer.size() > RingBufferMaxLength) {
      ptDownValueRingBuffer.remove(0);
    }
  }
}
